#!/bin/sh                         # perl
eval "exec ../../../perl -I../../../lib -S $0 $*"
	if 0;

use ExtUtils::MakeMaker;

use Config;
use DBI;

%defaults = DBI::MakeMakerAttribs();

unless ($ENV{'ORACLE_HOME'}){
	# try to find oracle ...
	foreach(qw(/usr/oracle /opt/oracle /usr/soft/oracle)){
		$ENV{'ORACLE_HOME'}=$_,last if -d "$_/rdbms/lib";
	}
	die "Unable to determine ORACLE_HOME" unless $ENV{'ORACLE_HOME'};
	warn "ORACLE_HOME set to $ENV{'ORACLE_HOME'}\n";
}

# read list of libs that oracle requires (eg -lm -lnsl)
chop($sysliblist = `cat $ENV{'ORACLE_HOME'}/rdbms/lib/sysliblist`);


%x=(%defaults,
	'potential_libs' => $sysliblist,
	'otherldflags'   => '$(ALLLIBS)',
	'INC' => "-I../../DBI -I$ENV{'ORACLE_HOME'}/rdbms/demo",
	'DISTNAME' => 'DBD-Oracle',
	'VERSION' => '0.1',
);
$ExtUtils::MakeMaker::Verbose = 1;
$x = &writeMakefile(%x);



sub MY::post_constants{
	'
# Constants
ORA_HOME = '."$ENV{'ORACLE_HOME'}".'
ORA_RDBLIBS = $(ORACLE_HOME)/rdbms/lib

# Oracle Definitions, based on $(ORACLE_HOME)/c/demo/proc.mk
# (the double sqlnet is intentional)
OCILIBS = -locic
NETLIBS = $(ORA_HOME)/lib/osntab.o -lsqlnet
ORALIBS = -lora -lcv6 -lcore -lsqlnet
ALLLIBS = -L$(ORA_HOME)/lib $(OCILIBS) $(NETLIBS) $(ORALIBS)
';
}


sub MY::distclean {
    '
distclean:     clean
	rm -f Makefile *~ t/*~
	cd ..; tar cvFf $(DISTNAME)-$(VERSION).tar \
		`sed -e "s:^:$(BASEEXT)/:" < $(BASEEXT)/MANIFEST`
	@cd ..; compress $(DISTNAME)-$(VERSION).tar;
	@chmod -w ../$(DISTNAME)-$(VERSION).tar.Z
	mv ../$(DISTNAME)-$(VERSION).tar.Z /home/timbo/perl/db/DBD/Oracle/
	@cd $$HOME/perl/db/DBD/Oracle; pwd; ls -l *.Z
';
}

