#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "Oracle.h"

/* Define dbh implementor data structure */
typedef struct {
    Lda_Def lda;
    ub1     hda[256];
} imp_dbh;

/* Define sth implementor data structure */
typedef struct sth_impd_t {
    Cda_Def lda;
    imp_dbh *dbh;

} imp_sth;


static SV *ora_errnum = NULL; /* see dbd_ora_init */
static SV *ora_errstr = &sv_undef;

static dbistate_t *dbis;

static void
dbd_ora_init()
{
    ora_errnum = GvSV(gv_fetchpv("DBD::Oracle::err", 1, SVt_IV));
    dbis = (dbistate_t*)SvIV(DBISTATE_ADDRSV);
    if (dbis == NULL)
	croak("Unable to get DBI state");
    if (dbis->version < DBISTATE_VERSION || dbis->size < sizeof(*dis)){
	warn("DBI/DBD version mismatch"
	dbis = NULL; /* to be checked elsewhere */
    }
}


static void
save_error(lda, rc, what)
    Lda_Def *lda;
    int	rc;
    char *what;
{
    char msg[999]; msg[0]='\0';
    oerhms(lda, rc, msg, sizeof(msg));
    sv_setiv(ora_errnum, (IV)rc);
    sv_setpv(ora_errstr, msg);
    if (dbis->debug >= 2)
	fprintf(dbis->log, "%s error %d recorded\n", what, rc);
}


MODULE = DBD::Oracle	PACKAGE = DBD::Oracle

BOOT:
    dbd_ora_init();

char *
errstr(h)
    SV *	h
    CODE:
    {
    ST(0) = sv_mortalcopy(ora_errstr);
    XSRETURN(1);
    }


MODULE = DBD::Oracle	PACKAGE = DBD::Oracle::dr

void *
orlon(uid, pwd)
    char *	uid
    char *	pwd
    CODE:
    {
    dbh_impd *d;
    ST(0) = sv_newmortal();
    if ( (d = safemalloc(sizeof(*d))) == NULL )
	croak("no memory");
    if (orlon(&d->lda, &d->hda, uid, -1, pwd, -1, 0)){
	save_error(&d->lda, d->lda.rc, "login failed");
	free(d);
	XSRETURN(1);
    }
    sv_setiv(ST(0), (IV)d);
    XSRETURN(1);
    }


